#ifndef DOT_EXTENSIONS_WIICONTROLLER_ENTITYPLUGINS_IWIICONTROLLED_H_3DOT
#define DOT_EXTENSIONS_WIICONTROLLER_ENTITYPLUGINS_IWIICONTROLLED_H_3DOT

#include <3DOT/entity/ientityplugin.h>

namespace EXT_WIICONTROLLER_3DOT
{
	/*
	GUID info:
		http://www.3dot.dk/wiki/index.php/EXTGUIDs%2C_CLSIDs%2C_and_IIDs
	GUID generator:
	    http://emanuelgreisen.dk/stuff/uuid.php?num=3

	GUIDFactory<0x9d40314f, 0xc429, 0x49d5, 0xb26f6c429395a810LL>()
				^^ used by IWiiControllerExtension
	GUIDFactory<0x406381ed, 0x7e86, 0x4bf8, 0xbe12d5cad67e948bLL>()
				^^ used by IWiiControllerTask
	GUIDFactory<0x5a3f909a, 0xb500, 0x4b0c, 0xa37a97ad24ed2f80LL>()
				^^ used by IWiiControlled
	GUIDFactory<0x87d409f6, 0x5043, 0x4965, 0x9a4793dea0875b4bLL>()
	*/
	#define IID_IWiiControlled GUIDFactory<0x5a3f909a, 0xb500, 0x4b0c,\
										   0xa37a97ad24ed2f80LL>()
	struct DLLEXPORT IWiiControlled : public CORE_3DOT::IEntityPlugin
	{
		// Sets/gets whether or not to make use of the reported orientation
		INTF_METH( void SetWiiControlledOrientation(bool) );
		INTF_METH( bool GetWiiControlledOrientation() const );

		// Sets/gets whether or not to make use of the reported position
		INTF_METH( void SetWiiControlledPosition(bool) );
		INTF_METH( bool GetWiiControlledPosition() const );

		// RTTI block
		DECLARE_RTTI_BEGIN(IWiiControlled, CORE_3DOT::IEntityPlugin)
			DECLARE_RTTI_METHOD("SetWiiControlledOrientation",
				IWiiControlled::SetWiiControlledOrientation)
			DECLARE_RTTI_METHOD("GetWiiControlledOrientation",
				IWiiControlled::GetWiiControlledOrientation)
			DECLARE_RTTI_METHOD("SetWiiControlledPosition",
				IWiiControlled::SetWiiControlledPosition)
			DECLARE_RTTI_METHOD("GetWiiControlledPosition",
				IWiiControlled::GetWiiControlledPosition)
		DECLARE_RTTI_END();
	};
	typedef HUnknown<IWiiControlled> HWiiControlled;
}

#endif
