#ifndef DOT_EXTENSIONS_WIICONTROLLER_IWIICONTROLLEREXTENSION_H_3DOT
#define DOT_EXTENSIONS_WIICONTROLLER_IWIICONTROLLEREXTENSION_H_3DOT

#include <3DOT/extension/iextension.h>

namespace EXT_WIICONTROLLER_3DOT
{
	/*
	GUID info:
		http://www.3dot.dk/wiki/index.php/EXTGUIDs%2C_CLSIDs%2C_and_IIDs
	GUID generator:
	    http://emanuelgreisen.dk/stuff/uuid.php?num=3

	GUIDFactory<0x9d40314f, 0xc429, 0x49d5, 0xb26f6c429395a810LL>()
				^^ used by IWiiControllerExtension
	GUIDFactory<0x406381ed, 0x7e86, 0x4bf8, 0xbe12d5cad67e948bLL>()
				^^ used by IWiiControllerTask
	GUIDFactory<0x5a3f909a, 0xb500, 0x4b0c, 0xa37a97ad24ed2f80LL>()
				^^ used by IWiiControlled
	GUIDFactory<0x87d409f6, 0x5043, 0x4965, 0x9a4793dea0875b4bLL>()
	*/
	#define IID_IWiiControllerExtension GUIDFactory<0x9d40314f, 0xc429, 0x49d5,\
													0xb26f6c429395a810LL>()
	struct DLLEXPORT IWiiControllerExtension : public CORE_3DOT::IExtension
	{
		// Updates and processes new controller data
		INTF_METH( void Process() );

		// Returns orientation of controller (axis-angle => quaternion)
		INTF_METH( CORE_3DOT::quat GetOrientation() const );
		// Returns position of controller
		INTF_METH( CORE_3DOT::vec3 GetPosition() const );

		// Returns button states changed event handle
		INTF_METH( CORE_3DOT::HEvent GetButtonStatesChangedEvent() );
		// Returns orientation changed event handle
		INTF_METH( CORE_3DOT::HEvent GetOrientationChangedEvent() );
		// Returns position changed event handle
		INTF_METH( CORE_3DOT::HEvent GetPositionChangedEvent() );

		// RTTI block
		DECLARE_RTTI_BEGIN(IWiiControllerExtension, CORE_3DOT::IExtension)
			DECLARE_RTTI_METHOD("Process", IWiiControllerExtension::Process)

			DECLARE_RTTI_METHOD("GetOrientation",
				IWiiControllerExtension::GetOrientation)
			DECLARE_RTTI_METHOD("GetPosition",
				IWiiControllerExtension::GetPosition)

			DECLARE_RTTI_METHOD("GetButtonStatesChangedEvent",
				IWiiControllerExtension::GetButtonStatesChangedEvent)
			DECLARE_RTTI_METHOD("GetOrientationChangedEvent",
				IWiiControllerExtension::GetOrientationChangedEvent)
			DECLARE_RTTI_METHOD("GetPositionChangedEvent",
				IWiiControllerExtension::GetPositionChangedEvent)
		DECLARE_RTTI_END();
	};
	typedef CORE_3DOT::ExtensionHandle<IWiiControllerExtension>
		HWiiControllerExtension;
}

#endif
