/*
// \file extensions/wiicontroller/wiicontrollertask.cpp
//
// Description:
// A task that calls WiiControllerExtension::Process as often as possible.
//
// \Author Anders Sabinsky Tgern <ast@hoast.dk>
// \Author Lasse Jon Fuglsang Pedersen <fuglsang@diku.dk>
//
// \Copyright See COPYING file that comes with the 3DOT distribution
*/

#include "wiicontrollertask.h"
#include <3DOT/extensions/wiicontroller/iwiicontrollerextension.h>
#include <3DOT/handles/extensionhandle.h>

namespace EXT_WIICONTROLLER_3DOT
{
	// Constructor
	WiiControllerTask::WiiControllerTask(CORE_3DOT::HScene scene)
		:
		CORE_3DOT::BaseScheduleTask<IWiiControllerTask>(scene)
	{
	}

	// Called by scheduler (args not in use as we only want to execute Process)
	void WiiControllerTask::Execute(double time_global, double time_step)
	{
		HWiiControllerExtension()->Process();
	}

	// This function specifies first execution time
	double WiiControllerTask::FirstExecutionTime() const
	{
		return 0;
	}

	// This function specifies execution interval
	double WiiControllerTask::ExecutionPeriod() const
	{
		return 0;
	}

	// This function specifies only one execution per frame
	bool WiiControllerTask::IsSingleton()
	{
		return true;
	}
}
