#ifndef EXTENSIONS_WIICONTROLLER_WIICONTROLLERTASK_H_3DOT
#define EXTENSIONS_WIICONTROLLER_WIICONTROLLERTASK_H_3DOT
/*
// \file extensions/wiicontroller/wiicontrollertask.h
//
// Description:
// A task that calls WiiControllerExtension::Process as often as possible.
//
// \Author Anders Sabinsky Tgern <ast@hoast.dk>
// \Author Lasse Jon Fuglsang Pedersen <fuglsang@diku.dk>
//
// \Copyright See COPYING file that comes with the 3DOT distribution
*/

#include <3DOT/extensions/wiicontroller/iwiicontrollertask.h>
#include <engine/basescheduletask.h>

namespace EXT_WIICONTROLLER_3DOT
{
	/*
	 * Class definition: WiiControllerTask
	 */

	class WiiControllerTask
		: public CORE_3DOT::BaseScheduleTask<IWiiControllerTask>
	{
	public:
		
		WiiControllerTask(CORE_3DOT::HScene scene);

	public:

		void	Execute(double time_global, double time_step);
		double	FirstExecutionTime() const;
		double	ExecutionPeriod() const;
		bool	IsSingleton();

	};
}

#endif
